<template>
  <section
    id="category-slug"
    class="category-slug animate__animated animate__fadeIn animate__faster"
  >
    <!-- <MainBanner /> -->

    <LocalLoader v-if="loading" />

    <section id="products-container">
      <!-- Productos por categoría -->
      <ProductsList
        :title="category.nombre"
        :products="products"
        :filters="true"
        :loading="loading"
        v-if="category && !loading"
      />

      <!-- Productos destacados por si la categoría no cuenta con productos -->
      <div class="mt-3">
        <ProductsList
          title="Productos destacados"
          :products="featuredProducts"
          :filters="false"
          :loading="loadingFeaturesProducts"
          v-if="!products.length"
        />
      </div>
    </section>

    <div class="d-flex justify-content-center mt-5">
      <b-pagination
        v-model="page"
        :total-rows="nroItems"
        :per-page="number_paginate"
        @change="paginate($event)"
        v-if="products.length && nroItems > number_paginate"
      ></b-pagination>
    </div>

    <ModalFilters
      :loading="loadingFilter"
      @filter="filter($event)"
      @cleanUp="cleanUp()"
    />
  </section>
</template>

<script>
import { appConfig } from "@/app-config.js";

import GetProductoCategoria from "@/graphql/queries/productos/categorias/GetProductoCategoria.gql";
import GetCategoriaSlug from "@/graphql/queries/productos/categorias/GetCategoriaSlug.gql";
import GetBusquedaAvanzada from "@/graphql/queries/productos/GetBusquedaAvanzada.gql";
import GetProductos from "@/graphql/queries/productos/GetProductos.gql";

// import MainBanner from "@/components/banner/MainBanner";
import ProductsList from "@/components/products/ProductsList";
import LocalLoader from "@/components/global/loaders/LocalLoader";
import ModalFilters from "@/components/products/ModalFilters";

export default {
  data() {
    return {
      number_paginate: appConfig.pagination.number_paginate,
      page: 1,
      nroItems: 0,
      // category: null,
      slug: this.$route.params.slug,
      products: [],
      featuredProducts: [],
      loading: false,
      loadingFeaturesProducts: false,
      loadingFilter: false,
      dataToFilter: null,
      filterStatus: false,
    };
  },
  head() {
    // Se utiliza https://vue-meta.nuxtjs.org/

    let slug = this.slug;

    let title = appConfig.openGraph.titulo,
      description = appConfig.openGraph.descripcion,
      logo = appConfig.openGraph.logo,
      url = appConfig.openGraph.urlWeb,
      whatsappImg = appConfig.openGraph.logo,
      keywords = appConfig.openGraph.keywords;

    if (this.category) {
      description = this.category.descripcion;
      title = this.category.nombre; // Graph
      logo = this.category.open_graph.url;
      keywords = this.category.keywords;
    }

    return {
      title,
      meta: [
        { name: "keywords", content: keywords },

        // Twitter Card
        { name: "twitter:card", content: "summary" },
        { name: "twitter:title", content: title },
        { name: "twitter:description", content: description },
        { name: "twitter:image", content: logo },

        // Facebook OpenGraph
        { property: "og:url", content: `${url}/categorias/${slug}` },
        { property: "og:title", content: title },
        { property: "og:site_name", content: title },
        { property: "og:type", content: "website" },
        { property: "og:image", content: logo },
        { property: "og:description", content: description },

        // Whatsapp OpenGraph
        { property: "og:url", content: `${url}/categorias/${slug}` },
        { property: "og:title", content: title },
        { property: "og:site_name", content: title },
        { property: "og:type", content: "website" },
        { property: "og:image", content: whatsappImg },
        { property: "og:description", content: description },
      ],
    };
  },
  async asyncData({ params, app, error }) {
    let apollo = app.apolloProvider.defaultClient;

    try {
      let response = await apollo.query({
        query: GetCategoriaSlug,
        variables: {
          slug: params.slug,
        },
      });

      return {
        category: response.data.GetCategoriaSlug,
      };
    } catch (e) {
      error({ statusCode: 404 });

      app.store.commit("SET_LOADER", false);
    }
  },
  async created() {
    if (this.$route.query.p) {
      this.page = this.$route.query.p;
    }

    if (this.category) {
      this.products = await this.getProducts();

      if (!this.products.length) {
        this.featuredProducts = await this.getFeaturedProducts();
      }
    }

    this.$store.commit("SET_LOADER", false);
  },
  components: {
    // MainBanner,
    ProductsList,
    LocalLoader,
    ModalFilters,
  },
  methods: {
    async getProducts() {
      try {
        this.loading = true;

        let response = await this.$apollo.query({
          query: GetProductoCategoria,
          variables: {
            slug: this.category.slug,
            number_paginate: this.number_paginate,
            page: this.page,
            estado: "",
          },
        });
        this.nroItems = response.data.GetProductoCategoria.NroItems;

        this.loading = false;

        return response.data.GetProductoCategoria.data;
      } catch (error) {
        console.log(error)
        this.$store.commit("SET_LOADER", false)
      }
    },
    async filter(event) {
      this.loadingFilter = true;

      this.dataToFilter = event;

      this.page = 1;
      this.$router.push({
        name: this.$route.name,
        params: this.$route.params,
        query: { p: 1 },
      });

      this.products = await this.getProductsByFilter();

      this.scrollTo();

      this.$bvModal.hide("modal-filters");
    },
    async cleanUp() {
      this.filterStatus = false;

      this.page = 1;
      this.$router.push({
        name: this.$route.name,
        params: this.$route.params,
        query: { p: 1 },
      });

      this.products = await this.getProducts();

      this.scrollTo();

      this.$bvModal.hide("modal-filters");
    },
    async getProductsByFilter() {
      let res = await this.$apollo.query({
        query: GetBusquedaAvanzada,
        variables: {
          number_paginate: this.number_paginate,
          page: this.page,
          precio: this.dataToFilter.precio,
          tipoOrdenacion: parseInt(this.dataToFilter.tipoOrdenacion),
          categoria_slug: this.dataToFilter.categoria_slug,
          tipoFavorito: 0,
        },
        fetchPolicy: "no-cache",
      });

      this.nroTotalItems = res.data.GetBusquedaAvanzada.NroItems;

      this.loadingFilter = false;
      this.filterStatus = true;

      return res.data.GetBusquedaAvanzada.data;
    },
    async getFeaturedProducts() {
      this.loadingFeaturesProducts = true;

      let response = await this.$apollo.query({
        query: GetProductos,
        variables: {
          number_paginate: this.number_paginate,
          page: this.page,
          estado: "1", // Visibles = 1, ocultos = 0
        },
        fetchPolicy: "no-cache",
      });

      this.loadingFeaturesProducts = false;

      return response.data.GetProductos.data;
    },
    async paginate(event) {
      this.page = event;

      this.$router.push({
        name: this.$route.name,
        params: this.$route.params,
        query: { p: event },
      });

      if (this.filterStatus) {
        this.products = await this.getProductsByFilter();
      } else {
        this.products = await this.getProducts();
      }

      const myEl = document.getElementById("products-container");

      this.$smoothScroll({
        scrollTo: myEl,
        updateHistory: false,
      });
    },
    scrollTo() {
      const elemento = document.getElementById("products-container");

      this.$smoothScroll({
        offset: -100,
        scrollTo: elemento,
        updateHistory: false,
      });
    },
  },
};
</script>

<style lang="scss">
.category-slug {
  min-height: 500px;
}
</style>
